/*     DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
                    Version 2, December 2004

 Copyright (C) 2009 Adinpsz contributors
  7 chemin Villebois 38100 Grenoble
 Everyone is permitted to copy and distribute verbatim or modified
 copies of this license document, and changing it is allowed as long
 as the name is changed.

            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

  0. You just DO WHAT THE FUCK YOU WANT TO. */
/* This program is free software. It comes without any warranty, to
 * the extent permitted by applicable law. You can redistribute it
 * and/or modify it under the terms of the Do What The Fuck You Want
 * To Public License, Version 2, as published by Sam Hocevar. See
 * http://sam.zoy.org/wtfpl/COPYING for more details. */ 
module audio.oggbuffer;

// a buffer which contains the decoded OGG

import util.all;
import audio.oggfile;
import derelict.ogg.vorbisfile;
import derelict.ogg.vorbiscodec;

class OGGBuffer
{
	private
	{
		Vector!(ubyte) m_data;
		int m_channels;
	}
	
	public
	{
		this(OGGFile oggFile)
		{
			m_data = new Vector!(ubyte)();
			load(oggFile);
			m_channels = oggFile.numChannels();
		}	
		
		void load(OGGFile oggFile)
		{
			const OGG_BUFFER_SIZE = 4096;
			ubyte[] buf;
			buf.length = OGG_BUFFER_SIZE;
			int section = 0;
			oggFile.open();
			
			while(true)
			{
				auto ret = ov_read(oggFile.handle, 
							       cast(byte *) buf.ptr, 
							       OGG_BUFFER_SIZE, 
							       0, // little-endian
							       2, // 16-bits
							       1, // signed
							       &section);
							       
				if ((ret == 0) || (section != 0))
		   		{
			   		debug(1) std.stdio.writefln("OGG buffering finished");
			   		break;	      					
		    	} else if (ret < 0) 
		    	{      
			    	std.stdio.writefln("error decoding OGG = %s", ret);		
			    	break;
		    	} else 
		    	{
			    	m_data.addArray(buf[0..ret]);	    				
				}
			}		
			oggFile.close();	
	
		}
		
		int numChannels()
		{
			return m_channels;
		}
		
		// address to the whole buffer
		short * data()
		{
			return cast(short *) m_data.ptr();	
		}
		 
		// length in samples (does'nt account for mono/stereo)
		int length()
		{
			return (m_data.size() >> 1);	
		}
	}
	
	
	
	
}