/*     DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
                    Version 2, December 2004

 Copyright (C) 2009 Adinpsz contributors
  7 chemin Villebois 38100 Grenoble
 Everyone is permitted to copy and distribute verbatim or modified
 copies of this license document, and changing it is allowed as long
 as the name is changed.

            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

  0. You just DO WHAT THE FUCK YOU WANT TO. */
/* This program is free software. It comes without any warranty, to
 * the extent permitted by applicable law. You can redistribute it
 * and/or modify it under the terms of the Do What The Fuck You Want
 * To Public License, Version 2, as published by Sam Hocevar. See
 * http://sam.zoy.org/wtfpl/COPYING for more details. */ 
module demo.az01;

import sdl.all;
import util.all;
import util.geometry.all;
import gl.all;
import demo.all;

// AZ-01 class
class AZ01 : SDLApp
{
	private
	{
		Demo m_demo;
		
	}
	
	public
	{
		this(int asked_width, int asked_height, float ratio, bool fullscreen, int fsaa, bool playMusic)
		{
			FSAA aa = void;
			if (fsaa == 2) aa = FSAA.FSAA2X;
			else if (fsaa == 4) aa = FSAA.FSAA4X;
			else if (fsaa == 8) aa = FSAA.FSAA8X;
			else if (fsaa == 16) aa = FSAA.FSAA16X;
			else aa = FSAA.OFF;				
				
			
			super(asked_width, asked_height, fullscreen, !false, "az-01", null, aa, 0);	
			
			SDL_ShowCursor(SDL_DISABLE);
			
			// adjust viewport according to ratio
			int w = width, h = height;
			
			auto window_ratio = width / cast(double)height;
			auto wanted_ratio = ratio;			
			
			if (window_ratio < wanted_ratio) // crop because of ratio if needed
			{
				h = cast(int)(w * (1.0 / wanted_ratio));
			} else if (window_ratio > wanted_ratio)
			{				
				w = cast(int)(h * wanted_ratio);
			}
			
			auto viewport = vec4i((width - w) >> 1, (height - h) >> 1, w, h);
			
			const SOUND_TRACK = "data/music/wullon_orange_guy.ogg";
			
			m_demo = new Demo( viewport, playMusic ? SOUND_TRACK : "" );	
			
			const int EFFECT = 0;
			const int TEXT_EFFECT = 1;
			const int TRANSITION = 2;
			const auto BEAT = 60.0 / 110.0;
			const auto BAR16 = 16.0 * BEAT;
			
			GL.vertexColorClamping = false;
			GL.fragmentColorClamping = false;
			
			
			// debug timeline
		//	m_demo.add(new Scene30(vec2d(0.0 * BEAT, 32.0 * BEAT), EFFECT));
		//	m_demo.add(new LogoFinalEffect(vec2d(BEAT * 0.f,BEAT * 80.f), EFFECT));			
		//	m_demo.add(new GDOShow(vec2d(BAR16 * 0.f,BAR16 * 8.f), TEXT_EFFECT));
		
			// real timeline
			m_demo.add(new Scene10(vec2d(0.0, 72.0 * BEAT), EFFECT));
			m_demo.add(new Scene20(vec2d(24.0 * BEAT, 72.0 * BEAT), EFFECT));	
			
			m_demo.add(new Fade( vec2d(70.0 * BEAT, 76.0 * BEAT), TRANSITION,
			           [vec4f(0.f,0.0f,0.f, 0.f), 
			            vec4f(0.f,0.0f,0.f, 1.f), 
			            vec4f(0.f,0.0f,0.f, 0.5f),
			            vec4f(0.f,0.0f,0.f, 0.f) ]));
			
			m_demo.add(new OrangeEffect( vec2d(72.0 * BEAT, 88.0 * BEAT), EFFECT));
			
				m_demo.add(new Fade( vec2d(87.0 * BEAT, 89.0 * BEAT), TRANSITION,
			           [vec4f(0.f,0.0f,0.f, 0.f), 
			            vec4f(0.f,0.0f,0.f, 1.f), 
			            vec4f(0.f,0.0f,0.f, 0.f) ]));
			
			m_demo.add(new Scene30(vec2d(88.0 * BEAT, 120.0 * BEAT), EFFECT));
			
			m_demo.add(new Fade( vec2d(199.5 * BEAT, 200.5 * BEAT), TRANSITION,
			           [vec4f(1.f,1.0f,1.f, 0.f), 
			            vec4f(1.f,1.0f,1.f, 1.f), 
			            vec4f(1.f,1.0f,1.f, 0.f) ]));
			
			m_demo.add(new TunnelEffect(vec2d(120.0 * BEAT, 200.0 * BEAT), EFFECT));
			
			m_demo.add(new Fade( vec2d(198.0 * BEAT, 202.0 * BEAT), TRANSITION,
			           [vec4f(0.f,0.0f,0.f, 0.f), 
			            vec4f(0.f,0.0f,0.f, 1.f), 
			            vec4f(0.f,0.0f,0.f, 0.f) ]));
			
			m_demo.add(new BallEffect( vec2d(200.0 * BEAT, 228.0 * BEAT), EFFECT));
			
			m_demo.add(new LogoFinalEffect( vec2d(216.0 * BEAT, 228.0 * BEAT), TEXT_EFFECT));
			
			//m_demo.add(new DFCEffect( vec2d(0, 4.5), EFFECT));			
			 
			m_demo.loadEverything(); // initiate loading 	
		}	
		
		float a = 0;
		
	    override void OnRender(double elapsedTime)
	    {
		   m_demo.draw(elapsedTime);
			
			swapBuffers();
		}
	    
	    override void OnMove(double elapsedTime, float dt)
	    {
			m_demo.move(elapsedTime, dt);
			if (m_demo.finished) terminate;
		}
	    
	    override void OnKeyUp(int key)
	    {
			if (key == SDLK_ESCAPE) terminate();    
	    }
	    
	    override void OnFrameRateChanged(float frameRate)
	    {
	/*	    title = format("adinpsz FPS=%s", frameRate); 
		    writefln("FPS: %s", frameRate);
	  */}
	    
	    override void OnKeyDown(int key)  
	    {  
	/*	    const auto BEAT = 60.0 / 110.0;
			const auto BAR16 = 16.0 * BEAT;
			if (key == SDLK_LEFT) m_demo.timeTravel (-BAR16);
			if (key == SDLK_RIGHT) m_demo.timeTravel (+BAR16);		    
	*/	}	    
		
	    override void OnMouseMove(int x, int y, int dx, int dy)  { }	    
	    override void OnMouseDown(int button)	    { }	    
	    override void OnMouseUp(int button)	    { }	    
	    override void OnReshape(int width, int height)  {  }	    
    }	
}


