/*     DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
                    Version 2, December 2004

 Copyright (C) 2009 Adinpsz contributors
  7 chemin Villebois 38100 Grenoble
 Everyone is permitted to copy and distribute verbatim or modified
 copies of this license document, and changing it is allowed as long
 as the name is changed.

            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

  0. You just DO WHAT THE FUCK YOU WANT TO. */
/* This program is free software. It comes without any warranty, to
 * the extent permitted by applicable law. You can redistribute it
 * and/or modify it under the terms of the Do What The Fuck You Want
 * To Public License, Version 2, as published by Sam Hocevar. See
 * http://sam.zoy.org/wtfpl/COPYING for more details. */ 
module demo.fade;

private import demo.effect;
private import demo.demo;
private import util.all;
private import util.geometry.all;
private import gl.all;


class Fade : Effect
{
	private 
	{
		vec4f[] m_sequence; // sequence of colors to be displayed fullscreen		
		
		vec4f m_color;
		
		ShaderProgram m_shader;
		
		/**
		 * special fade interpolation
		 */
		T faceInterp(T)(T[] table, float index)
		{
			if (index < 0)
			{
				return table[0];	
			}		
			else if (index >= table.length - 1) 
			{
				return table[table.length - 1];
			}
			else 
			{
				int ipart = cast(int)(index);
				float fpart = index - ipart;	
			//	fpart * fpart * (3.f - 2.f * fpart); 		
				T a = table[ipart] * (1 - fpart);	
				T b = table[ipart + 1] * fpart;	
				return a + b;
			}
		}
		
		final vec4f getColor(float t)
		{
			 return linearInterp(m_sequence, t * m_sequence.length);			 
		}
	}
	
	public
	{
		this(vec2d interval, int priority, vec4f[] sequence)
		{
			super("Fade", interval, priority);
			m_shader = new ShaderProgram("data/shaders/put_vertex.glsl", "data/shaders/put_pixel.glsl");
			m_sequence = sequence;		
			m_color = getColor(0);
		}	
		
		override bool isPaperEffect() { return false; }					
			
		override void onLoad() // load resources
		{		
		}
		
		override void onDraw() // draw effect
		{
			
			demo.mainFBO().use();
			m_shader.use();
			    		    
			GL.projectionMatrix = mat4f.IDENTITY;
			GL.modelviewMatrix = mat4f.IDENTITY;
				
			GL.disable( [ GL_TEXTURE_2D, GL_DEPTH_TEST, GL_ALPHA_TEST, GL_LINE_SMOOTH, GL_POLYGON_SMOOTH, GL_POINT_SMOOTH] );
			GL.enable(GL_BLEND);			
			
			GL.setBlend(GL.BlendMode.ADD, GL.BlendFactor.SRC_ALPHA, GL.BlendFactor.ONE_MINUS_SRC_ALPHA,
 			            GL.BlendMode.MAX, GL.BlendFactor.ONE, GL.BlendFactor.ONE);
 			            
 			            
 			auto c = m_color; 			
 			glColor4fv(c.ptr);
			
			glBegin(GL_QUADS);
				glVertex2f(-1,-1);	
				glVertex2f(+1,-1);
				glVertex2f(+1,+1);
				glVertex2f(-1,+1);				
			glEnd();			
		}		
		
		override void onMove(double dt) // move effect
		{
			m_color = getColor(progression);
		}
	}
	
	
}
