/*     DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
                    Version 2, December 2004

 Copyright (C) 2009 Adinpsz contributors
  7 chemin Villebois 38100 Grenoble
 Everyone is permitted to copy and distribute verbatim or modified
 copies of this license document, and changing it is allowed as long
 as the name is changed.

            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

  0. You just DO WHAT THE FUCK YOU WANT TO. */
/* This program is free software. It comes without any warranty, to
 * the extent permitted by applicable law. You can redistribute it
 * and/or modify it under the terms of the Do What The Fuck You Want
 * To Public License, Version 2, as published by Sam Hocevar. See
 * http://sam.zoy.org/wtfpl/COPYING for more details. */ 
module sdl.joystick;

private import derelict.sdl.sdl;	
private import util.common;

class SDLJoystick
{
	private
	{
		SDL_Joystick *handle;
		int index;
		
		const PRESSED = true, 
		      RELEASED = false;
		
		bool[] button_pressed;
		float[] axis;
		char[] name;
		
		void open(int num)
		{
			this.index = num;
			handle = SDL_JoystickOpen(num);
		}
		
		void close()
		{
			if (opened()) SDL_JoystickClose(handle);	
		}
		
		bool opened()
		{
			return (SDL_JoystickOpened(index) != 0);
		}
	}
	
	public
	{
		this(int index)
		{	
			open(index);
			
			button_pressed.length = SDL_JoystickNumButtons(handle);
			button_pressed[] = RELEASED;
			
			axis.length = SDL_JoystickNumAxes(handle);
			axis[] = 0.f;
			
			name = toDString(SDL_JoystickName(index));
			
		}
		
		~this()
		{			
			close();
		}
		
		bool getButton(int i)
		{
			return (button_pressed[i] == PRESSED);	
		}
		
		void setButton(int i, bool newValue)
		{
			button_pressed[i] = newValue;
		}
		
		void setAxis(int i, float newValue)
		{
			axis[i] = newValue;	
		}
		
		float getAxis(int i)
		{
			return axis[i];	
		}	
		
		int getNumAxis()
		{
			return axis.length;
		}
		
		int getNumButtons()
		{
			return button_pressed.length;
		}	
		
		char[] getName()
		{
			return name;	
		}			
	}	
}